script.on_event(defines.events.on_gui_click, function(event)
    local element = event.element
    if element.valid ~= false then
        return;
    end

    local eventName = element.name;

    if eventName == 'team_chat_button' then
        local player = game.players[event.player_index];
        TeamChat:make_team_chat_gui(player);
    elseif eventName == 'team_chat_message_close' then
        local player = game.players[event.player_index];
        player.gui.center.team_chat.destroy()
    elseif eventName == 'team_number_check' then
        local player = game.players[event.player_index]
        table.each(global.forcesData, function(data)
            local c = 0;
            table.each(game.players, function(p)
                if data.cName == p.force.name then c = c + 1 end
            end)
            player.print({ 'teams.player-msg-team-number', data.title, c })
        end)
    elseif string.match(eventName, 'choose_team_.*') ~= nil then
        table.each(global.forcesData, function(data)
            if eventName == 'choose_team_' .. data.name then
                local player = game.players[event.player_index]
                player.teleport(game.forces[data.cName].get_spawn_position(s), s)
                player.color = data.color
                player.force = game.forces[data.cName]
                player.gui.left.choose_team.destroy()
                player.insert { name = "iron-plate", count = 8 }
                player.insert { name = "pistol", count = 1 }
                player.insert { name = "firearm-magazine", count = 10 }
                player.insert { name = "burner-mining-drill", count = 1 }
                player.insert { name = "stone-furnace", count = 1 }
                Alliance:make_alliance_overlay_button(player);
                TeamChat:make_team_chat_button(player);
                PrintToAllPlayers({ 'teams.player-msg-team-join', player.name, data.title })
            end
        end)
    elseif eventName == 'alliance_button' then
        local player = game.players[event.player_index]
        Alliance:buildAllianceGui(player)
    elseif eventName == 'alliance_close' then
        local player = game.players[event.player_index]
        if player.gui.center.alliance ~= nil then
            player.gui.center.alliance.destroy();
        end
    elseif string.match(eventName, 'make_alliance_.*') ~= nil then
        local player = game.players[event.player_index];
        local forceTwo = string.sub(event.element.name, 15);
        local forceOne = player.force.name;
        if isAllianceRequested(forceOne, forceTwo) then
            Alliance:deleteRequest(forceOne, forceTwo);
            game.forces[forceOne].set_cease_fire(forceTwo, true)
            game.forces[forceTwo].set_cease_fire(forceOne, true)
            Alliance:updateChangeable(forceOne, forceTwo);
            Alliance:updateGuis()
            PrintToAllPlayers({ 'teams.alliance-accept', player.name, global.forcesData[forceTwo].title, global.forcesData[forceOne].title })
        elseif game.forces[forceOne].get_cease_fire(forceTwo) and game.forces[forceTwo].get_cease_fire(forceOne) then
            game.forces[forceOne].set_cease_fire(forceTwo, false)
            game.forces[forceTwo].set_cease_fire(forceOne, false)
            Alliance:updateChangeable(forceOne, forceTwo);
            Alliance:updateGuis()
            PrintToAllPlayers({ 'teams.alliance-terminated', player.name, global.forcesData[forceTwo].title, global.forcesData[forceOne].title })
        else
            Alliance:requestAlliance(forceOne, forceTwo);
            Alliance:updateGuis()
            PrintToAllPlayers({ 'teams.alliance-request', player.name, global.forcesData[forceTwo].title, global.forcesData[forceOne].title })
        end
    elseif string.match(eventName, 'alliance_deny_.*') ~= nil then
        local player = game.players[event.player_index];
        local forceTwo = string.sub(event.element.name, 15);
        local forceOne = player.force.name;
        if Alliance:isAllianceRequested(forceOne, forceTwo) then
            Alliance:deleteRequest(forceOne, forceTwo);
            Alliance:updateGuis()
            game.forces[forceOne].set_cease_fire(forceTwo, false)
            game.forces[forceTwo].set_cease_fire(forceOne, false)
            PrintToAllPlayers({ 'teams.alliance-denied', player.name, global.forcesData[forceTwo].title, global.forcesData[forceOne].title })
        end
    elseif string.match(eventName, 'alliance_abort_.*') ~= nil then
        local player = game.players[event.player_index];
        local forceTwo = string.sub(event.element.name, 16);
        local forceOne = player.force.name;
        if Alliance:isAllianceRequested(forceOne, forceTwo) then
            Alliance:deleteRequest(forceOne, forceTwo);
            Alliance:updateGuis()
            PrintToAllPlayers({ 'teams.alliance-abort', player.name, global.forcesData[forceTwo].title, global.forcesData[forceOne].title })
        end
    elseif string.match(eventName, 'make_alliance_.*') ~= nil then
        local player = game.players[event.player_index];
        local forceTwo = string.sub(event.element.name, 15);
        local forceOne = player.force.name;
        if Alliance:isAllianceRequested(forceOne, forceTwo) then
            Alliance:deleteRequest(forceOne, forceTwo);
            game.forces[forceOne].set_cease_fire(forceTwo, true)
            game.forces[forceTwo].set_cease_fire(forceOne, true)
            Alliance:updateChangeable(forceOne, forceTwo);
            Alliance:updateGuis()
            PrintToAllPlayers({ 'teams.alliance-accept', player.name, global.forcesData[forceTwo].title, global.forcesData[forceOne].title })
        elseif game.forces[forceOne].get_cease_fire(forceTwo) and game.forces[forceTwo].get_cease_fire(forceOne) then
            game.forces[forceOne].set_cease_fire(forceTwo, false)
            game.forces[forceTwo].set_cease_fire(forceOne, false)
            Alliance:updateChangeable(forceOne, forceTwo);
            Alliance:updateGuis()
            PrintToAllPlayers({ 'teams.alliance-terminated', player.name, global.forcesData[forceTwo].title, global.forcesData[forceOne].title })
        else
            Alliance:requestAlliance(forceOne, forceTwo);
            Alliance:updateGuis()
            PrintToAllPlayers({ 'teams.alliance-request', player.name, global.forcesData[forceTwo].title, global.forcesData[forceOne].title })
        end
    elseif eventName == 'next_step' then
        local p = game.players[event.player_index];
        ConfigurationGui:try(ConfigurationGui.steps[ConfigurationGui.currentStep].saveStep, p);
        ConfigurationGui:try(ConfigurationGui.steps[ConfigurationGui.currentStep].destroyStep, p);
        ConfigurationGui.currentStep = ConfigurationGui.steps[ConfigurationGui.currentStep].nextStep;
        local g = ConfigurationGui:try(ConfigurationGui.steps[ConfigurationGui.currentStep].createStep, p);
        ConfigurationGui:createNextAndPrev(g);
    elseif eventName == 'prev_step' then
        local p = game.players[event.player_index];
        ConfigurationGui:try(ConfigurationGui.steps[ConfigurationGui.currentStep].saveStep, p);
        ConfigurationGui:try(ConfigurationGui.steps[ConfigurationGui.currentStep].destroyStep, p);
        ConfigurationGui.currentStep = ConfigurationGui.steps[ConfigurationGui.currentStep].prevStep;
        local g = ConfigurationGui:try(ConfigurationGui.steps[ConfigurationGui.currentStep].createStep, p);
        ConfigurationGui:createNextAndPrev(g);
    elseif eventName == 'start_game' then
        local p = game.players[event.player_index];
        ConfigurationGui:try(ConfigurationGui.steps[ConfigurationGui.currentStep].saveStep, p);
        ConfigurationGui:try(ConfigurationGui.steps[ConfigurationGui.currentStep].destroyStep, p);
        PrintToAllPlayers({ "teams.lobby-msg-config-finished", game.players[1].name })
        make_forces()
        setConfigWritten();
    elseif eventName == 'force_cancel' then
        local p = game.players[event.player_index];
        if p.gui.center.create_force ~= nil and p.gui.center.create_force.valid then
            p.gui.center.create_force.destroy();
        end
        ConfigurationGui:createNextAndPrev(ConfigurationGui.steps.teams.createFrame(p));
    elseif eventName == 'force_save' then
        local p = game.players[event.player_index];
        if p.gui.center.create_force ~= nil and p.gui.center.create_force.valid then
            if p.gui.center.create_force.caption ~= nil then
                global.forcesData[p.gui.center.create_force.caption] = nil;
            end
            local forceData = ConfigurationGui.steps.teams.getForceData(p.gui.center.create_force);
            if forceData.cName ~= '' then
                global.forcesData[forceData.cName] = forceData;
                p.gui.center.create_force.destroy();
            end
        end
        ConfigurationGui:createNextAndPrev(ConfigurationGui.steps.teams.createFrame(p));
    elseif eventName == 'force_remove' then
        local element = event.element;
        local p = game.players[event.player_index];
        local parent = element.parent;
        table.each(global.forcesData, function(forceData, k)
            if parent.name == 'force_frame_' .. forceData.name then
                global.forcesData[k] = nil;
            end
        end)
        ConfigurationGui:createNextAndPrev(ConfigurationGui.steps.teams.createFrame(p));
    elseif string.match(eventName,'force_edit_(.*)') ~= nil then
        local element = event.element;
        local p = game.players[event.player_index];
        table.each(global.forcesData, function(forceData)
            if element.valid and element.name == 'force_edit_' .. forceData.name then
                if p.gui.center.teams_gui ~= nil then
                    p.gui.center.teams_gui.destroy();
                end
                ConfigurationGui.steps.teams.createForceGuiWithData(p, forceData);
                return;
            end
        end)
    elseif eventName == '' then
    end
end)